import { ofType } from 'redux-observable';
import { concat, of } from 'rxjs';
import { switchMap } from 'rxjs/operators';

import { GET_USER_ACCOUNTS_OPTIONS } from '@/graphql/services/users/constants';

import { PAYLOAD_NAME } from '@/graphql/services/users/types/payload/accounts';

import { getAccountOptionsAction, setAction } from '../slices';
import { gqlRequest } from '@/modules/@common/request';

const query = `
  query ${GET_USER_ACCOUNTS_OPTIONS}($payload: ${PAYLOAD_NAME}) {
    ${GET_USER_ACCOUNTS_OPTIONS}(payload: $payload) {
      id
      name
      type
      publishers {
        id
        name
      }
    }
  }
`;

const getResponse = ({ data }) =>
  data[GET_USER_ACCOUNTS_OPTIONS].map((account) => ({
    ...account,
    value: account.id,
    label: account.name,
  }));

export default (action$) =>
  action$.pipe(
    ofType(getAccountOptionsAction.type),
    switchMap((action) => {
      const stream$ = gqlRequest({
        query,
        variables: {
          payload: {
            searchText: action.payload ?? '',
            pageSize: 30,
          },
        },
      }).pipe(
        switchMap((response) => {
          const actions = [];

          if (!response.errors.length) {
            const accountOptions = getResponse(response);

            actions.push(
              of(
                setAction({
                  accountOptions,
                }),
              ),
            );
          }

          return concat(...actions);
        }),
      );

      return concat(stream$);
    }),
  );
